{ This is a replacement for the TTrackBar component that supports a
  track bar with or without range selection.

  Set EnableRange to True/False to toggle the display of the range
  selection bar on and off.

  Component written by:
   Richard Hansen
   Artemis Alliance, Inc.
   289 E 5th St. #211
   St. Paul, MN 55101

   (612) 227-7172
   71042.2142@compuserve.com

   Delphi design, consulting and development.

}
unit RHTrack;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, CommCtrl;

type
  TrhTrackBar = class(TTrackBar)
  private
    FEnableRange : Boolean;

    procedure SetEnableRange(AState : Boolean);

  public
    procedure CreateParams(var Params: TCreateParams); override;

  published
    property EnableRange: Boolean read FEnableRange write SetEnableRange;
  end;

procedure Register;

implementation


procedure TrhTrackBar.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);

  if FEnableRange then
    Params.Style := Params.Style or TBS_ENABLESELRANGE
  else
    Params.Style := Params.Style and not TBS_ENABLESELRANGE;
end;

procedure TrhTrackBar.SetEnableRange(AState : Boolean);
begin
  if (FEnableRange <> AState) then begin
    FEnableRange := AState;
    RecreateWnd;
  end;
end;


procedure Register;
begin
  RegisterComponents('Samples', [TrhTrackBar]);
end;

end.

